function [tss bestOriPerLoc tssFull] = ABtest_one(XYS,oriRange,model,S1Map)

% S1 Map is the S1 map for a single image : 1 * numScale * numOrient
% destFolder : destination folder
% NB (neighborhood): a set of points (x,y,o) that the template is allowed
%   to move to

h = model.h;
sx = model.sx;
sy = model.sy;
Mi = model.Mi;
Mx = model.Mx;
My = model.My;
Mm = model.Mm;
Mm1 = model.Mm1;
Lrange = model.Lrange;
Orange = model.Orange;
sub = model.sub;
Totalsketch = model.Totalsketch;
logBigZ = log(model.bigZ);

nimage = 1;
norient = size(S1Map,3);

nScale = max(XYS(:,3));
bestOriPerLoc = zeros(size(XYS,1),1);
tss = zeros(size(XYS,1),1);
offset = 0;
tssFull = zeros(length(oriRange),size(XYS,1));
for iScale = 1:nScale
    partial_XYS = XYS(XYS(:,3)==iScale,:);
    NB = zeros(size(partial_XYS,1)*length(oriRange),3);
    count = 1;
    for i = 1:size(partial_XYS,1)
        for o = oriRange
            NB(count,:) = [partial_XYS(i,1) partial_XYS(i,2) o];
            count = count + 1;
        end
    end
    Sx1 = size(S1Map{1,iScale,1},1);
    Sy1 = size(S1Map{1,iScale,1},2);
    tmp_tss = zeros(length(oriRange),size(partial_XYS,1));
    X0 = 0; Y0 = 0;
    CScanMatching(nimage,norient,S1Map(1,iScale,:),h,sx,sy,X0,Y0,Sx1,Sy1,...
        Mi,Mx,My,Mm,Mm1,Lrange,Orange,sub,Totalsketch,...
        tmp_tss,NB);
    tmp_tss = tmp_tss - logBigZ;
    [tmp_tss_maximized_over_orientation tmp_bestOriPerLoc_ind] = max(tmp_tss,[],1);
    tssFull(:,offset+( 1:size(partial_XYS,1) ) ) = tmp_tss;
    tss( offset+( 1:size(partial_XYS,1) ) ) = tmp_tss_maximized_over_orientation;
    bestOriPerLoc( offset+( 1:size(partial_XYS,1) ) ) = oriRange(tmp_bestOriPerLoc_ind);
    offset = offset + size(partial_XYS,1);
end




