function overlayed = displayExtentsOnExamples(nValid,tx,norient,BB_size_per_scale,images, topExtents, sym)

n = length(images);
srcImages = cell(n,1);

resizedBBsize = BB_size_per_scale(end);
for k = 1:n
    [originalSX originalSY] = size(images{k});

    % fit the original image tightly into this bounding box (biggest)

    srcImages{k} = zeros(resizedBBsize,resizedBBsize);
    if originalSX >= originalSY
        sxList(k) = resizedBBsize;
        syList(k) = floor(.5+resizedBBsize*originalSY/originalSX);
        srcImages{k}(:,(1:syList(k))+floor((resizedBBsize-syList(k))/2)) = imresize(images{k},[sxList(k) syList(k)],'nearest');
    else
        syList(k) = resizedBBsize;
        sxList(k) = floor(.5+resizedBBsize*originalSX/originalSY);
        srcImages{k}((1:sxList(k))+floor((resizedBBsize-sxList(k))/2),:) = imresize(images{k},[sxList(k) syList(k)],'nearest');
    end
end

overlayed = cell(n,1);
for i = 1:n
    overlayed{i} = double(srcImages{i}) / 2;
end

for k = 1:nValid
    % ( x, y, scale, orientation, image ID, iLoc )
    imageID = topExtents(k,5);
    if imageID == 0
        continue;
    end
    imageScale = topExtents(k,3);

    resizedBBsize = BB_size_per_scale(imageScale);
     % overlay bounding box on src images
     mask = sym;
%      mask([1:5 tx-4:tx],:) = 1;
%      mask(:,[1:5 tx-4:tx]) = 1;
     tmpRotatedMask = zeros(resizedBBsize,resizedBBsize);
     CDrawRotate(1,norient,{mask},{tmpRotatedMask},tx,resizedBBsize,resizedBBsize,topExtents(k,1)-1,topExtents(k,2)-1,topExtents(k,4));
     tmpRotatedMask = imresize(tmpRotatedMask,[BB_size_per_scale(end) BB_size_per_scale(end)],'nearest');
     tmpDest = double(overlayed{imageID});
     tmpDest(tmpRotatedMask > 0) = 255;
     overlayed{imageID} = tmpDest;
end

