function dumpNeg(tx)

% to dump S1 maps of negative examples

if exist(sprintf('NegS1Maps_%d.mat',tx), 'file')
    disp(sprintf('NegS1Maps_%d.mat already exists.', tx));
    return;
end

negFolder = 'bigNeg';
Iname = dir(sprintf('%s/*.jpg',negFolder));
nImage = length(Iname);

images = cell(nImage,1);
for iImage = 1:nImage
    im = imread(sprintf('%s/%s',negFolder,Iname(iImage).name));
    if size(im,3) == 3
        im = rgb2gray(im);
    end
    % for convenience, cut the image into a square
    minSize = min([size(im,1),size(im,2)]);
    im = im(1:minSize,1:minSize);
    images{iImage} = double(im);
end


% compute multi-scale S1 Maps (locally normalized) and the void maps (to shut down structure-less patches) 
[XYS BB_size_per_scale grid_step_size] = getLocs(tx);
XYS = XYS(1:85,:);
BB_size_per_scale = BB_size_per_scale(1:4);
nLoc = size(XYS,1);

norient = 16;
load('nlf.mat','scale','Upperbound');
[allFilter allsymbol] = makefilter(scale, norient);  % generate Gabor filters 
[S1Maps voidMaps] = getS1Maps(allFilter,images,XYS,BB_size_per_scale);
save(sprintf('NegS1Maps_%d.mat',tx),'S1Maps','voidMaps','XYS','BB_size_per_scale');
