function [XYS BB_size_per_scale grid_step_size grid ] = getFineLocs(tx,nScale)
%
% Obtain quantized level-2 locazations from the template size.
% <tx> template size (template is a square)
%

% We start from the first scale which is the outer bounding square.

% We specify the basic grid hierarchy (we use the log scale)

% scale 0 : (2^0*2 - 1)^2 = 1 * 1
% scale 0.5 : (2^0*3-1)^2 = 2 * 2
% scale 1 : (2^1*2-1)^2 = 3 * 3
% scale 1.5: (2^1*3-1)^2 = 5 * 5
% scale 2: (2^2*2-1)^2 = 7 * 7
% scale 2.5: (2^2*3-1)^2 = 11 * 11
% scale 3: (2^3*2-1)^2 = 15 * 15

% In total 7 scales may be enough.

% The above is only the basic grid. It is probably necessary to still 
%   sample points in between grid points. The actual grid would be:

% #inner-sample-point : the number of points to insert between each two sampled points 
num_inner_sample_point = 3;

% scale 0: (no need to record)

% scale 0.5 ~ 3:
grid_width = [ 1/2 1/3 1/4 1/6 1/8 1/12 1/16 ]; % more can be added



grid = zeros(7,3);
count = 1; % including scale = 0
for s = 2:nScale
    step = tx / 2 / (num_inner_sample_point+1);
    grid(s,1) = 1; % start
    grid(s,2) = step;
    grid(s,3) = tx/grid_width(s)/2 - tx + 1; % end
    count = count + length(grid(s,1):grid(s,2):grid(s,3))^2;
end

XYS = zeros(count,3); k = 1;

BB_size_per_scale = zeros(nScale,1);
for s = 1:nScale
    BB_size_per_scale(s) = tx/grid_width(s)/2;
end

% s = 0 
XYS(k,:) = [1 1 1]; % x y scale bounding_square_size
k = k + 1;

for s = 2:nScale
    for x = grid(s,1) : grid(s,2) : grid(s,3)
        for y = grid(s,1) : grid(s,2) : grid(s,3)
            XYS(k,:) = [floor(x+.5) floor(y+.5) s];
            k = k + 1;
        end
    end
end

grid_step_size = step;
